--- old/usr/src/cmd/mdb/common/mdb/mdb_print.c	Thu Aug  1 18:13:05 2013
+++ new/usr/src/cmd/mdb/common/mdb/mdb_print.c	Thu Aug  1 18:13:05 2013
@@ -24,7 +24,7 @@
  */
 
 /*
- * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright (c) 2012 Joyent, Inc. All rights reserved.
  */
 
@@ -707,9 +707,10 @@
 	if (argv->a_type != MDB_TYPE_STRING) {
 		/*
 		 * We are being given a raw offset in lieu of a type and
-		 * member; confirm the arguments.
+		 * member; confirm the number of arguments and argument
+		 * type.
 		 */
-		if (argv->a_type != MDB_TYPE_IMMEDIATE)
+		if (argc != 1 || argv->a_type != MDB_TYPE_IMMEDIATE)
 			return (DCMD_USAGE);
 
 		offset = argv->a_un.a_val;
@@ -726,6 +727,13 @@
 		char buf[MDB_SYM_NAMLEN];
 		int ret;
 
+		/*
+		 * Check that we were provided 2 arguments: a type name
+		 * and a member of that type.
+		 */
+		if (argc != 2)
+			return (DCMD_USAGE);
+
 		ret = args_to_typename(&argc, &argv, buf, sizeof (buf));
 		if (ret != 0)
 			return (ret);
